<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             sebba
 * @copyright          sebba - 2018
 * @license            GNU/GPL, see LICENSE.php
 */

// no direct access
defined('_JEXEC') or die;

class plgEventBookingAutocoupons extends JPlugin
{
	protected $table = '#__eb_autocoupons';
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		JFactory::getLanguage()->load('plg_eventbooking_autocoupons', JPATH_ADMINISTRATOR);		
	}

	public function onEditEvent($row, $isNew)
	{
		ob_start();
		$this->drawSettingForm($row);

		return array(
			'title' => JText::_('EB_AUTOCOUPONS'),
			'form'  => ob_get_clean(),
		);
	}

	 ///////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function onAfterSaveEvent($row, $data, $isNew)
	{
		// The plugin will only be available in the backend
		$app = JFactory::getApplication();

		// return if not in administration area
		if ($app->isSite())
		{
			return;
		}

		$db    = JFactory::getDbo();
		$query = $db->getQuery(true);

		
		//citire date din formurile de input
		$agc_ids        = $data['form_cid']; 
		$agc_parents	= $data['form_agc_parent']; 
		$agc_bindeds	= $data['form_agc_binded']; 
///		$agc_vals       = $data['form_agc_val'];
		$agc_val       = $data['form_agc_val'];
///		$agc_types      = $data['form_agc_type'];
		$agc_type      = $data['form_agc_type'];
///		$agc_timess     = $data['form_agc_times'];
		$agc_times     = $data['form_agc_times'];
///		$agc_untils 	= $data['form_agc_until'];
		$agc_until 	= $data['form_agc_until'];


		
		$agCouponsIds          = array();
		
		//resetam daca event-ul este nou ---- deocamdata e inutil, nu afisez drawSettingForm pentru eventuri nesalvate
		if ($isNew)
		{
			// Reset ID of ticket type
			for ($i = 0, $n = count($agc_ids); $i < $n; $i++)
			{
				$agc_ids[$i] = 0;
				echo "isnew".$n."<br>";
			}
		}
		
		// inserare sau modificare inregistrari in baza de date - PARENT EVENT - pentru fiecare TITLE
		for ($i = 0, $n = count($agc_ids); $i < $n; $i++)
		{
			$cid = $agc_ids[$i];

			if (empty($agc_bindeds[$i]))
			{
				continue;
			}

			$agc_parent			= (int) $agc_parents[$i];
			$agc_binded			= (int) $agc_bindeds[$i];
///			$agc_val            = (int) $agc_vals[$i];
///			$agc_type           = (int) $agc_types[$i];
///			$agc_times 			= (int) $agc_timess[$i];
///			$agc_until 			= (int) $agc_untils[$i];

			$query->clear();
			
			if ($cid) //update inregistrari existente
			{
				$query->update('#__eb_autocoupons')
					->set('agc_parent = ' . $agc_parent)
					->set('agc_binded = ' . $agc_binded)
					->set('agc_val = ' . $agc_val)
					->set('agc_type = ' . $agc_type)
					->set('agc_times = ' . $agc_times)
					->set('agc_until = ' . $agc_until)
					->where('cid = ' . $cid);
			}
			else //insert inregistrari noi
			{
				$query->insert('#__eb_autocoupons')
					->columns('agc_parent, agc_binded, agc_val, agc_type, agc_times, agc_until')
					->values("$agc_parent, $agc_binded ,$agc_val, $agc_type, $agc_times, $agc_until");
			}


			$db->setQuery($query);
			$db->execute();

			if ($cid)
			{
				$agCouponsIds[] = $cid;
			}
			else
			{
				$agCouponsIds[] = $db->insertid();
			}
		}
		
		//stergere inregistrari
		if (count($agCouponsIds))
		{
			//echo "cid ptr stergere=".$cid."<br>";
			
			$query->clear()
				->delete('#__eb_autocoupons')
				->where('agc_parent = ' . $row->id)
				->where('cid NOT IN (' . implode(',', $agCouponsIds) . ')');
			$db->setQuery($query);
			$db->execute();
		}
		else
		{
			//sterge ultima inregistrare, cand count devine zero si nu se mai aplica regula de mai sus. adica se sterg toate inregistrarile eventului parinte
			$query->clear()
				->delete('#__eb_autocoupons')
				->where('agc_parent = ' . $row->id);
				//->where('cid NOT IN (' . implode(',', $agCouponsIds) . ')');
			$db->setQuery($query);
			$db->execute();
		}
	
	}
	

	 ///////////////////////////////////////////////////////////////////////////////////////////////////////////

	 ///////////////////////////////////////////////////////////////////////////////////////////////////////////
	private function drawSettingForm($row)
	{
		if (empty($row->id))
		{
			echo "Available only for SAVED events. Returning!";
			return;
		}

		if ($row->parent_id > 0)
		{
			echo "Available only for PARENT events. Returning!";
			return;
		}
		//event list for dropdown selector
		//$eventslist = array();
		
		$db       = JFactory::getDbo();
		$query    = $db->getQuery(true);

		//lista pentru eventuri cu parent_id = 0
		$query->clear()
				->select('id, title')
				->from('#__eb_events')
				->where('parent_id = 0')
				->order('title');
		$db->setQuery( $query );
		$items_from_db = $db->loadObjectList();
		$eventslist[] = JHTML::_('select.option',  '0', "- Select event -", 'id', 'title' );
		$eventslist = array_merge( $eventslist, $items_from_db);

		$agCoupons = array();

		if ($row->id > 0)
		{
			$query->clear()
				->select('cid, agc_parent, agc_binded, agc_val, agc_type, agc_times, agc_until')
				->from('#__eb_autocoupons')
				->where('agc_parent = ' . (int) $row->id)
				->order('cid');
			$db->setQuery($query);
			$agCoupons = $db->loadObjectList();
		}	
		
		?>
		<center>Enter parameters for the auto-geenrated coupon and set the events where the coupon will apply</center>
		<hr>
				<table align="center"><tbody>
					<td class="nowrap center"><?php echo JText::_('EB_AGC_VAL'); ?><br><input type="text" class="input-medium" name="form_agc_val"
								value="<?php echo $agCoupons[0]->agc_val; ?>" /></td>
					<td><?php echo JText::_('EB_AGC_TYPE'); ?><br><input type="text" class="input-mini" name="form_agc_type"
								value="<?php echo $agCoupons[0]->agc_type; ?>"/>
				<!--	<?php 
						JFormHelper::loadFieldClass('radio');
						$field = new JFormFieldRadio();
						$field->setup(new SimpleXMLElement('<field name="form_agc_val" type="radio" size="1" default="1" class="btn-group btn-group-yesno"><option value="1">Amount (€)</option><option value="0">Percent (%)</option></field>'), $agCoupons[0]->agc_type);
						echo $field->renderField(array('hiddenLabel'=>true));
						 ?>
				-->				
					</td>									
					<td><?php echo JText::_('EB_AGC_TIMES'); ?><br><input type="text" class="input-mini" name="form_agc_times"
								value="<?php echo $agCoupons[0]->agc_times; ?>"/></td>
					<td><?php echo JText::_('EB_AGC_UNTIL'); ?><br><input type="text" class="input-mini" name="form_agc_until"
								value="<?php echo $agCoupons[0]->agc_until; ?>" /></td>

				</tr><tbody></table><hr>

			<div class="row-fluid">
			<div class="span51">
				<table align="center" id="adminAGCForm">
					<thead>
					<tr>
						<!--<th class="nowrap center"><?php echo JText::_('EB_AGC_PARENT'); ?></th>-->
						<th class="nowrap center"><?php echo JText::_('EB_AGC_BINDED'); ?></th>
					<!--	<th class="nowrap center"><?php echo JText::_('EB_AGC_VAL'); ?></th>
						<th class="nowrap center"><?php echo JText::_('EB_AGC_TYPE'); ?></th>
						<th class="nowrap center"><?php echo JText::_('EB_AGC_TIMES'); ?></th>
						<th class="nowrap center"><?php echo JText::_('EB_AGC_UNTIL'); ?></th> -->
						<th class="nowrap center"><?php echo JText::_('EB_REMOVE'); ?></th>
					</tr>
					</thead>
					<tbody id="additional_agc_options">
					
					
					<?php
					$numberagCoupons = max(count($agCoupons), 1);
					for ($a = 0; $a < $numberagCoupons; $a++)
					{
						if (isset($agCoupons[$a]))
						{
							$agCoupon = $agCoupons[$a];
						}
						else
						{
							//valori in formurile de input daca nu exista inregistrari
							//$agCoupon              	= new stdClass;
							$agCoupon->cid          = '';
							$agCoupon->agc_parent   = '';
							$agCoupon->agc_binded   = '';
///							$agCoupon->agc_val 		= '';
///							$agCoupon->agc_type  	= '';
///							$agCoupon->agc_times    = '';
//							$agCoupon->agc_until 	= '';		
						}
						
					
								
						?>
						<tr id="opt_agc_<?php echo $a; ?>">
							<td>
								<input type="hidden" class="input-mini" name="form_cid[]" value="<?php echo $agCoupons->cid; ?>"  />
								<input type="hidden" class="input-mini" name="form_agc_parent[]"
								       value="<?php echo $row->id; ?>"  />

							<!--	<input type="text" class="input-medium" name="form_agc_binded[]" 
									value="<?php echo $agCoupon->agc_binded; ?>" />
							-->
							<?php echo JHtml::_('select.genericlist', $eventslist, 'form_agc_binded[]', '', 'id', 'title', $agCoupon->agc_binded); ?>


							</td>
							
					<!--		<td><input type="text" class="input-medium" name="form_agc_val[]"
							        value="<?php echo $agCoupon->agc_val; ?>" <?php if ($a > 0) echo " readonly "; ?>/></td>

							<td><input type="text" class="input-mini" name="form_agc_type[]"
							           value="<?php echo $agCoupon->agc_type; ?>"<?php if ($a > 0) echo " readonly "; ?>/>
								   
							</td>

						   <td><input type="text" class="input-mini" name="form_agc_times[]"
							           value="<?php echo $agCoupon->agc_times; ?>"<?php if ($a > 0) echo " readonly "; ?>/></td>
							<td><input type="text" class="input-mini" name="form_agc_until[]"
							           value="<?php echo $agCoupon->agc_until; ?>"<?php if ($a > 0) echo " readonly "; ?>/></td> -->
							<td>
								<button type="button" class="btn btn-danger"
								        onclick="removeAGCContainer(<?php echo $a; ?>)"><i
										class="icon-remove"></i><?php echo JText::_('EB_REMOVE'); ?></button>
							</td>
						</tr>
						<?php
					}
					?>
					</tbody>
				</table>
				<center><button type="button" class="btn btn-success" onclick="addAGCContainer()"><i
						class="icon-new icon-white"></i><?php echo JText::_('EB_ADD'); ?></button></center>
			</div>
		</div>
		<script language="JavaScript">
			function removeAGCContainer(id) {
				if (confirm('<?php echo JText::_('EB_REMOVE_ITEM_CONFIRM'); ?>')) {
					jQuery('#opt_agc_' + id).remove();
				}
			}
			(function ($) {
				var countAGC = <?php echo $numberagCoupons; ?>;
				addAGCContainer = (function () {
					var html = '<tr id="opt_agc_' + countAGC + '">'
					html += '<td><input type="hidden" class="input-mini"name="form_cid[]" value = "" readonly /><input type="hidden" class="input-mini" name="form_agc_parent[]" value="<?php echo $row->id; ?>" readonly />';
					html += '<?php echo preg_replace(array('/\r/', '/\n/'), '', JHtml::_('select.genericlist', $eventslist, 'form_agc_binded[]', '', 'id', 'title', $agCoupon->agc_binded)); ?><!--/<input type="text" class="input-medium" name="form_agc_binded[]" value="" />--></td>';
					html += '<!--<td><input type="text" class="input-medium" name="form_agc_val[]" value="<?php echo $agCoupon->agc_val; ?>" readonly /></td>';
					html += '<td><input type="text" class="input-mini" name="form_agc_type[]" value="<?php echo $agCoupon->agc_type; ?>" readonly /></td>';
					html += '<td><input type="text" class="input-mini" name="form_agc_times[]" value="<?php echo $agCoupon->agc_times; ?>" readonly /></td>';
					html += '<td><input type="text" class="input-mini" name="form_agc_until[]" value="<?php echo $agCoupon->agc_until; ?>" readonly /></td>-->';
					html += '<td><button type="button" class="btn btn-danger" onclick="removeAGCContainer(' + countAGC + ')"><i class="icon-remove"></i><?php echo JText::_('EB_REMOVE'); ?></button></td>';
					html += '</tr>';
					$('#additional_agc_options').append(html);
					countAGC++;
				})
			})(jQuery)
		</script>
		<?php
	}
	public function onAfterPaymentSuccess($row)
	{
		//$row->registration_code = EventbookingHelperRegistration::getRegistrationCode();
		
		

	if (strpos($row->payment_method, 'os_offline') == false)
		{
			$reg_code = $row->registration_code;
			$this->processAGC($row);
		}
	}

	public function onAfterStoreRegistrant($row)
	{
		if (strpos($row->payment_method, 'os_offline') != false)
		{
			$this->processAGC($row);
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function processAGC($row) {
		
		$db    = JFactory::getDbo();
		$query = $db->getQuery(true);

		$userId = $row->user_id;
		//$reg_Eid = $row->event_id;
		

		
		// extracting parent's ID for cheching if this event - if child - should auto-generate coupons
		$query->clear()
			->select('parent_id')
			->from('#__eb_events')
			->where('id = ' . $row->event_id);
		$db->setQuery($query);
		$parentid = $db->loadObject();
		$Pid=$parentid->parent_id;

		$eid = $row->id;
		if ($Pid != 0) 
		{ $eid = $Pid; }

		//echo "parent_id=".$eid."<br>";

		$agCoupons = array();
		$query->clear()
			->select('cid, agc_parent, agc_binded, agc_val, agc_type, agc_times, agc_until')
			->from('#__eb_autocoupons')
			->where('agc_parent = ' . $eid);
		$db->setQuery($query);
		$agCoupons = $db->loadObjectList();
		$array = json_decode(json_encode($agCoupons), True);

		// generate random code for inserting in coupon's code
		function generateRandomString($length = 9) {
			$characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
			$charactersLength = strlen($characters);
			$randomString = '';
			for ($i = 0; $i < $length; $i++) {
				$randomString .= $characters[rand(0, $charactersLength - 1)];
			}
			return $randomString;
		}		

		//if displayed event should auto-generate coupons
		$nr_agc = count($array);
		if ($nr_agc > 0 and $userId > 0) {

			$rand_code = generateRandomString(); 
			$active_event = $row->event_id;

			//values for the auto-generated coupon (taken from the first instantce - I will modifiy the input form of coupons to have a proper management
			$agc_type 	= $array[0]['agc_type'];
			$agc_val 	= $array[0]['agc_val'];			
			$agc_total_val = $agc_val * $row->number_registrants;
			$agc_times 	= $array[0]['agc_times'];
			$agc_until = $array[0]['agc_until'];
			$agc_valid_from = date("Y-m-d H:i", time());
			$agc_valid_until = date("Y-m-d", time() + ($agc_until*86400));  //adding days for the valability of the coupon
			
			if ($agc_until < '1') {$agc_valid_until = '0';}

				$query->clear()
					->insert('#__eb_coupons')
					->columns('code, coupon_type, discount, event_id, times, used, valid_from, valid_to, published, user_id, apply_to')
					->values("'$userId$rand_code', '$agc_type', '$agc_total_val', '1', '$agc_times', '0','$agc_valid_from','$agc_valid_until','1',$userId,'1'");				
				$db->setQuery($query);
				$db->execute();

				$last_id = $db->insertid();

				
				for ($i = 0; $i < count($array); $i++) {

				$agc_binded = $array[$i]['agc_binded'];

				//defining array for event's children
				$ev_child=array();
				$query->clear()
					->select('id')
					->from('#__eb_events')
					->where('parent_id = '.$agc_binded)
					//->where('id = '.$eid)
					->order('id ASC');
				$db->setQuery($query);
				$ev_child = $db->loadObjectList();
				$ev_childs = json_decode(json_encode($ev_child), True);				

				//echo "<pre>"; 
				//print_r($ev_childs);
				//echo "</pre>"; 

					for ($a = 0; $a < count($ev_childs); $a++) {
						$Bid= $ev_childs[$a]['id'];
						//inserare cupoane ptr fiecare event afectat
						$query->clear()
							->insert('#__eb_coupon_events')
							->columns('coupon_id, event_id')
							->values("$last_id, $Bid");				
						$db->setQuery($query);
						$db->execute();			
					}

			}
			//publicam ID-ul ca sa nu il mai activeze inca o data
			//$query->clear()
			//	->update('#__eb_coupons')
			//	->set('published = 1')
			//	->where('id = ' . $last_id);
			//$db->setQuery($query);
			//$db->execute();			
		}
		
		//stergem eventurile alocate cuponului utilizat si declaram cuponul ca nepublicat
		if ($row->coupon_id > 0) {
		$query->clear()
				->delete('#__eb_coupon_events')
				->where('event_id != ' . $row->event_id)
				->where('coupon_id = ' . $row->coupon_id);
			$db->setQuery($query);
			$db->execute();			

		//unpublish used coupon
		$query->clear()
				->update('#__eb_coupons')
				->set('published = 0')
				->where('id = ' . $row->coupon_id);
			$db->setQuery($query);
			$db->execute();			
		}
	}
	
	public function onEventDisplay($row) {

		$user =& JFactory::getUser();

		//daca userul este logat verificam si afisam mesaje cand are cupoane pe care le poate folosi
		if($user->get( 'id' )) {

			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);		

			//numarul de cupoane disponibile ptr userul logat
			$cupoane = array();

			$query->clear()
				->select('user_id, id, code, discount, coupon_type, valid_to')
				->from('#__eb_coupons')
				->where('user_id = ' . $user->get( 'id' ) )
				->where('used = "0"')
				->where('published = 1');
			$db->setQuery($query);
			$cupoane = $db->loadObjectList();
			$cupoane = json_decode(json_encode($cupoane), True);				
			$agcnr = count($cupoane);

			foreach ($cupoane as $value){ 
			//echo "id=".$value[id]."<br>";  	
			//echo "code=".$value[code]."<br>";  	
			//echo "event=".$row->id."<br>";  	
			//$coduri = array();

				$query->clear()
					->select('COUNT(*)')
					->from('#__eb_coupon_events')
					->where('coupon_id = ' . $value[id] )
					->where('event_id = ' . $row->id );
				$db->setQuery($query);
				$count = $db->loadResult();
				if ($count > 0) {
					$coduri = $value[code]; 
					JFactory::getApplication()->enqueueMessage('Coupon code available: <b>'.$coduri.'</b> - Discount: <b>'.$value[discount].'</b> - Valid until: <b>'.$value[valid_to].'</b>', 'notice');
					}
		
			}

			//afisam mesajul de instiintare - cupon existent
			$message = ''; //resetare continut mesaj
			//if ($agcnr == 1) {$message = "You have ". $agcnr ." coupon available! Click here for coupon's detail page. ";}
			//if ($agcnr > 1) {$message = "You have ". $agcnr ." coupons available! Click here for coupons detail page. ";}
			
			JFactory::getApplication()->enqueueMessage($message, 'notice');

			//adaugam mesaj aditional daca event-ul afisat este afectat de cuponul existent	
			//if ($count > 0) { JFactory::getApplication()->enqueueMessage('Coupon code available for this event: '.$coduri, 'notice'); 
			//}		

		}

	}

}
